/*
 * Copyright (C) 2005 Cesar Kallas
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * E-mail: cesarkallas@gmx.net
 * http://cesarkallas.soulivre.org
 *
 */

package estella;
import  estella.lib.*;
import  estella.cliente.*;
import  estella.servidor.*;
import  estella.gui.*;

import java.lang.Thread;

/**
* Estella - Servent para a rede Gnutella v.4 - Classe principal
* @author Cesar Kallas - cesarkallas@gmx.net
* @since 21/11/2005
*/
class Estella
{
	private static Constantes CON;
	private Log LOG;
	private Cliente CLIENTE;
	private static Servidor SERVIDOR;
	private static Thread t_cliente, t_servidorWeb, t_servidor, t_gui;
	public static ConexaoLista servents, clientes;

	public static void main(String Args[])
	{	
		// Estrutura de dados compartilhadas pelas threads
		CON = new Constantes();
		Dados.onlineServents = new ServentLista();
		Dados.offlineServents = new ServentLista();
		Dados.onlineClientes = new ServentLista();
		
		Dados.arquivos = new ArquivoLista();
		Dados.listaDescritores = new DescritorLista();
		Dados.queryRepassadas = new DescritorLista();
		Dados.pingRepassados = new DescritorLista();
		Dados.pingEnviados = new DescritorLista();
		Dados.queryEnviados = new DescritorLista();
		Dados.debug = false;
		
		Dados.numArqComp = 0;
		Dados.tamArqComp = 0;
		Dados.download = 0;
		Dados.upload = 0;
		Dados.ip = new String("");
		
		if(Args.length > 0) {
			if(Args[0].equals("--debug"))
				Dados.debug = true;
			else
			if(Args[0].equals("--help")) {
				System.out.println("Uso: java estella/Estella [--debug]");
				return;
			}
		}
		
		// Interface grafica
		t_gui = new Thread(new JanelaPrincipal());
		t_gui.start();
		
		// Servidor de conexao
		t_servidor = new Thread(new Servidor());
		t_servidor.start();

		// Servidor web
		t_servidorWeb = new Thread(new ServidorWeb());
		t_servidorWeb.start();
		
	}
}
